SystemOrganization addCategory: #'SCouchDB-JQuery-Tests'!
SystemOrganization addCategory: #'SCouchDB-JQuery-Tests-Functional'!
SystemOrganization addCategory: #'SCouchDB-JQuery-Tests-Functional-mobile'!

WAComponent subclass: #JQAlbumDelete
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile'!

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/12/2013 00:32'!
renderAlbumRemoveScriptOn:html
| aScript |

"we need the _revision"
aScript:=JSScript new.
aScript add: ((JSStream on: 'doc') assign:((GRSmallDictionary new) 
	at: '_id' put:((html jQuery:#dataStorage) dataAt:#currentDoc);
	at: '_rev' put:((html jQuery:#dataStorage) dataAt:#currentRev);yourself
)). 
	
html document addLoadScript: 
((html jQuery:#deleteOkButton) onClick:(
(html jQuery couch db:'albums';removeDoc: aScript;
					onSuccess:(html jQuery mobile changePageUrl:  '/_seaside/albums' options:nil);
					onError:(( html jQuery:#fHeader) text:'Error deleting a Doc')
)))! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:08'!
renderContentOn:html
	self renderDeleteAlbumHeaderOn:html.
 	self renderDeleteAlbumContentOn:html.
   	self renderDeleteAlbumFooterOn:html.
	self renderAlbumRemoveScriptOn:html! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:08'!
renderDeleteAlbumContentOn:html
  html div
      jqmContent;
      with: [
	html heading level3 with:'Are you sure you want to remove this album?']
	! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:12'!
renderDeleteAlbumFooterOn:html
html div
      jqmFooter;
	jqmFixedPosition;	
      with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor
								jqmIcon: 'minus';
								id:#deleteOkButton;
								with: 'Ok' ].
						html listItem: [
							html anchor jqmTransitionSlide	
							jqmIcon: 'gear';
								onClick:((JSStream on:'history') call:'back');
								with: 'Cancel'.
							] ] ].

] ! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:12'!
renderDeleteAlbumHeaderOn:html
html div
      jqmHeader;
      with: [
         html heading
            level1;
		id:#fHeader;
            with: 'Delete Album']! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:09'!
renderLoginHeaderOn:html
html div
      jqmHeader;
      with: [
         html heading
            level1;
            with: 'Delete Album']! !

WAComponent subclass: #JQAlbumEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile'!

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 09:45'!
json
	^ JSJson new! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:32'!
loadSkeletonOn:html
	html div
      		jqmHeader;
      		with:  [	  
				   html heading
					id:#eHeader;
    			   	   level1;
      			   with:''.
				
				html anchor
           			 	class: 'ui-btn-right';
            			jqmIcon: 'home';
					url:'#pageId1';
            			with: 'Home' ].
	html div
			id:#eContent;
      		jqmContent;
      		with: ''.
	self renderAlbumEditorFooterOn:html.
	self renderAttachmentsOn:html! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:16'!
renderAlbumEditorContentOn:html


			html div jqmContainerTwoColumn; with: [
			html div jqmColumnOne; with: [
			html form id:#saveForm;post;with:[				
				self renderFormElementOn:html element:[
				html label
					for:#artist;
					with:'Artist:'.
				html textInput id:#artist;name:#artist;value:(html mustache variable:'artist').
				].
				self renderFormElementOn:html element:[
				html label
					for:#title;
					with:'Title:'.
				html textInput id:#title;name:#title;value:(html mustache variable:'title')].
				self renderFormElementOn:html element:[
				html label
					for:#description;
					with:'Description:'.
				html textInput id:#description;name:#description;value:(html mustache variable:'description')].
				self renderFormElementOn:html element:[
				html hiddenInput id:#user;name:#user;value: (self session sessionData at:'name')].
				self renderFormElementOn:html element:[
				html hiddenInput id:#rev;name:#_rev;value: (html mustache variable:'_rev')].
				self renderFormElementOn:html element:[
				html hiddenInput id:#id;name:#_id;value: (html mustache variable:'_id')].
				]
			].
			html div jqmColumnTwo; with: [
				html form id:#saveAttachmentForm;post;action:nil;multipart;with:[  
					html fileUpload id:#_attachments;name:#_attachments;multiple.  
					html hiddenInput id:#rev;name:#_rev;value: (html mustache variable:'_rev').
				].
				html div id:#attachmentsContent. 
			]
			
		]! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:23'!
renderAlbumEditorFooterOn:html

html div
			id:#eFooter;
      		jqmFooter;
			jqmFixedPosition;
      		with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor jqmTransitionSlidedown
								jqmIcon: 'back';
								onClick:((JSStream on:'history') call:'back');
								with: 'Cancel' ].
						html listItem: [
							html anchor jqmTransitionSlidedown
							 	id:#saveButton;
								jqmIcon: 'gear';
								with: 'save' ].		
					
			
			]
		]
	]! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/10/2013 16:57'!
renderAlbumEditorHeaderOn:html


      html html:(html mustache variable:'title').! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/14/2013 10:00'!
renderAlbumSaveAttachmentOn:html
| aScript |

aScript:=JSScript new.
aScript add: ((JSStream on: 'at') assign:
	((GRSmallDictionary new) 
	at: 'url' put: 
		((JSStream on: '"/albums/"') call:'concat' 
				with: ((html jQuery:#id) value) 
		);
	at: 'success' put:((( html jQuery:#eHeader) text:'Attachment added') asFunction);yourself )
).

^
((( html jQuery:#eHeader) text:'Attachment go')),
aScript,
	(((( html jQuery:#eHeader) text:'start trans')),
	((html jQuery:#saveAttachmentForm) call:'ajaxSubmit' with: (JSStream on:'at')),
	((( html jQuery:#eHeader) text:'end trans'))) condition:((html jQuery:#_attachments) value )! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:36'!
renderAlbumSaveScriptOn:html

| aScript |

aScript:=JSScript new.
aScript add: ((JSStream on: 'doc') assign:((GRSmallDictionary new) 
	at: 'artist' put:((html jQuery:#artist) value);
	at: 'title' put:((html jQuery:#title) value);
	at: 'user' put:((html jQuery:#user) value);
	at: '_id' put:((html jQuery:#id) value);
	at: '_rev' put:((html jQuery:#rev) value);
	at: 'description' put:((html jQuery:#description) value);
	at: '_attachments' put:(JSStream on:'attachments');yourself)). 

html document addLoadScript: (
(html jQuery:#saveButton) onClick:(
aScript,
"remove id and rev property if they were nul"
(((JSStream on: 'doc') property:'_id') not then: (JSStream on: 'delete doc._id')),
(((JSStream on: 'doc') property:'_rev') not then: (JSStream on: 'delete doc._rev')),
(html jQuery couch db:'albums';saveDoc: (JSStream on:'doc');
					onSuccess:(
								((html jQuery:'input[name="_rev"], form') each:( 
										html jQuery new value:(JSStream on:'doc._rev' ))) ,
								(( html jQuery:#eHeader) text:'Document saved'),
								(self renderAlbumSaveAttachmentOn:html),
								((JSStream on:'history')call:'back'));
					onError:(( html jQuery:#eHeader) text:'Error saving document'))
)
)! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 12:16'!
renderAlbumViewLoadScriptOn:html
"Loads a doc from CouchDb and renders Mustache templates"
html document addLoadScript:(
(html jQuery page onShow:(
   	html jQuery couch db:'albums';openDoc:((html jQuery:#dataStorage) 
											dataAt:#currentDoc);
					onSuccess:(
						"attachments global var stores temporally the doc attachments
						we need them to save them back"
						(((html jQuery event)access:'_attachments') assignTo:'attachments' ),
						(( html jQuery:#eContent) 
							mustache: (html jQuery:#aeContent) html
							data:(html jQuery event);
							trigger: 'create') ,
						(( html jQuery:#eHeader) 
							mustache: (html jQuery:#aeHeader) html
							data:html jQuery event
							command:'text'),
						"attachments are javascript dictionaries indexed by a filename, Mustache can not handle this kind of structure, it handles objects with well-know properties or arrays of objects "
						(( html jQuery:#attachmentsContent) 
							mustache: (html jQuery:#tAttachments) html
							data:((JSStream on:'attachmentsToArray') apply: (Array with:( html jQuery event)));
							trigger:'create')),
						(self renderAttachmentsDeleteOn: html);
					onError:(
						(( html jQuery:#eContent) 
							mustache: (html jQuery:#aeContent) html
							data:(html jQuery event);
							trigger: 'create') ,
						(( html jQuery:#eHeader) 
							text:'New Album'))
	))
)! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:21'!
renderAttachmentsDeleteOn:html
"register a delete attachment function on a click event for each element with the class .del (anchor in edit album) building an HTTP call:
DELETE /somedatabase/some_doc?rev=1582603387.
It must be registered after Mustache template is loaded"
^
(((html jQuery:'.del') each:((html jQuery new) onClick:(
					((((((html jQuery this) previous)previous) attributeAt:'src') call:'toString') assignLocalTo: 'aUrl'),
					(((JSStream on:'aUrl') call:'concat' with: '?rev=' with:(((html jQuery:#rev) value) call:'toString' )) assignLocalTo:'aU'),
					(html jQuery ajax 
							url: (JSStream on:'aU');
							type:'delete';
							onSuccess: ((JSStream on:'history') call:'back')
							
					)))))
			
	
! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 18:45'!
renderAttachmentsOn:html
html mustache template:'tAttachments';with:[
	html paragraph: 'Attachments:'.
	html mustache section 
		name:'_attachments';
		with:[
			html image class:'img';
				url: '/albums/',(html mustache variable:'_id') , 
					'/',
					(html mustache variable:'filename'). 
			html break.
			html anchor jqmButton;class:'del';
			with:'remove'.	
					
		]. 
	
]! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 18:38'!
renderContentOn:html
self renderAlbumViewLoadScriptOn:html.	
self renderAlbumSaveScriptOn:html.
self renderAlbumSaveAttachmentOn:html.
self loadSkeletonOn:html.
html mustache template:'aeHeader';
	with:[self renderAlbumEditorHeaderOn:html].
html mustache template:'aeContent';
	with:[self renderAlbumEditorContentOn:html].
html mustache template:'aeFooter';
	with:[self renderAlbumEditorFooterOn:html].



! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/10/2013 16:59'!
renderFormElementOn: html element: elementBlock
	html div
		jqmFieldContainer;
		with: [
			elementBlock value ]! !

WAComponent subclass: #JQAlbumView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile'!

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/4/2013 00:05'!
json
	^ JSJson new! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 12:22'!
loadSkeletonOn:html
"renders a mobile skeleton(the static content) page"
	html div
      		jqmHeader;
      		with:  [	  
				   html heading
					id:#bHeader;
    			   	   level1.
      			   "with:....will be filled by mustache"
				
				html anchor
           			 	class: 'ui-btn-right';
            			jqmIcon: 'home';
					jqmTransitionSlide; 
					url:'#pageId1';
            			with: 'Home' ].
	html div
			id:#bContent;
      		jqmContent.
		 	"with:....will be filled by mustache"
		
	self renderAlbumViewFooterOn:html.
	self renderAttachmentsOn:html! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:48'!
renderAlbumViewContentOn:html
"it is loaded as a mustache template"
		html div jqmContainerTwoColumn; with: [
			html div jqmColumnOne; with: [
				html heading
            			level1;
            			with:(html mustache variable:'artist').
				html paragraph:(html mustache variable:'title').
				html paragraph:(html mustache variable:'description').
				html paragraph:(html mustache variable:'user')].
			html div jqmColumnTwo; with: [
				html div id:#bAttachmentsContent.
				"with:...will be filled later by mustache"
									]
								
		]		
		
		! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 12:23'!
renderAlbumViewFooterOn:html

html div
			id:#dFooter;
      		jqmFooter;
			jqmFixedPosition;
      		with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor jqmTransitionSlidedown
								jqmIcon: 'minus';
								jqmDialog;
								jqmTransitionFlip;
								callback: [
									self session loggedIn 
										ifTrue:[self show:JQAlbumDelete new]
										ifFalse:[self show: JQAlbumsLogin new].
									];
								with: 'Delete' ].
						html listItem: [
							html anchor jqmTransitionSlidedown
							 	id:#editButton;
								jqmIcon: 'gear';
								callback: [
									self session loggedIn 
										ifTrue:[self show:JQAlbumEditor new]
										ifFalse:[self show: JQAlbumsLogin new].
									];
								with: 'Edit' ].						
					] 
			]
]! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:42'!
renderAlbumViewHeaderOn:html
"this template only updates the text content of the html heading. We don't want to replace other tags because we want to preserve mobile classes"

      html html:(html mustache variable:'title').

	! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:47'!
renderAlbumViewLoadScriptOn:html
"loads an album document and fill the empty skeleton with mustache templates"
html document addLoadScript:(
html jQuery page onShow:(
   	html jQuery couch db:'albums';openDoc:((html jQuery:#dataStorage) 
											dataAt:#currentDoc);
					onSuccess:(
						(( html jQuery:#bContent) 
							mustache: (html jQuery:#avContent) html
							data:html jQuery event) ,
						(( html jQuery:#bHeader) 
							mustache: (html jQuery:#avHeader) html
							data:html jQuery event
							command:'text'),
						"Couchdb attachments need a transformation from jsscript dictionary 
						to an array of pair index->value, in order to be rendered in a mustache template
						attachmentsToArray is defined within development lib and is not present 
						if you don't use this lib"
						(( html jQuery:#bAttachmentsContent) 
							mustache: (html jQuery:#avAttachments) html
							data:((JSStream on:'attachmentsToArray') apply: (Array with:( html jQuery event)))));
					onError:((html jQuery:#aView)  html:'Error in connection')
		 
		)
	)
	! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:45'!
renderAttachmentsOn:html
html mustache template:'avAttachments';with:[
	html paragraph: 'Attachments:'.
	html mustache section 
		name:'_attachments';
		with:[
			html image
				url: '/albums/',(html mustache variable:'_id') , 
					'/',
					(html mustache variable:'filename') ]. 
	
]! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:34'!
renderContentOn:html
self renderAlbumViewLoadScriptOn:html.	
self loadSkeletonOn:html.
"render mustache templates"
html mustache template:'avHeader';
	with:[self renderAlbumViewHeaderOn:html].
html mustache template:'avContent';
	with:[self renderAlbumViewContentOn:html].
html mustache template:'avFooter';
	with:[self renderAlbumViewFooterOn:html].

	! !

WAComponent subclass: #JQAlbumsList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile'!

!JQAlbumsList class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/6/2013 23:00'!
canBeRoot
^true! !

!JQAlbumsList class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:28'!
register
JQMAdmin register: self asApplicationAt: 'albums'! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/6/2013 17:50'!
json
	^ JSJson new! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 12:21'!
renderAlbumListContentOn:html

		html div
      		jqmContent;
      		with: [	
				html unorderedList 
					id:#listContent;
      				jqmListView.
      				
			].
		
html mustache 
		template:#al;
		with:[		
			html mustache 
				section name:'rows';
				with:[  
           			html listItem
					with: [
      				html anchor
						id: (html mustache variable:'id');
						title: (html mustache variable:'value._rev');
						jqmTransitionSlide; 
						callback:[self show:JQAlbumView new];
           					with: [
							html mustache section 
								name:'_attachments';
								with:[
									html image
						 				url: '/albums/',(html mustache variable:'_id') , 
										'/',
										(html mustache variable:'filename') ].
							html heading level1; with:(html mustache variable:'value.artist').
							html paragraph: (html mustache variable:'value.description').   
							html paragraph: (html mustache variable:'value.title').   
                      			]  .
 	      			
  		      
		] ] ].

! !

!JQAlbumsList methodsFor: 'accessing' stamp: 'JesusMari 2/12/2013 00:51'!
renderAlbumListFooterOn:html
html div
      jqmFooter;
	jqmFixedPosition;
      with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor jqmTransitionSlidedown
								jqmIcon: 'plus';
								onClick:	((html jQuery:#dataStorage) 
											dataAt:#currentDoc 
											put:	nil);
								callback: [
									self session loggedIn 
										ifTrue:[self show:JQAlbumEditor new]
										ifFalse:[self show: JQAlbumsLogin new].
									];
								with: 'Add' ].
						html listItem: [
							html anchor jqmTransitionSlidedown	
								jqmIcon:'search';
								with: 'Search' 
							] 
					] 
			]
	] ! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:31'!
renderAlbumListHeaderOn:html
html div
	id:#dataStorage;
      jqmHeader;
      with: [
         html heading
            level1;
            with:       [	html span:'Albums'].
	 ].
! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/14/2013 18:15'!
renderAlbumListLoadScriptOn:html
"we have to declare the event callback after the list  was updated and before it was refreshed because jQuery mobile will wrap our anchor tag with a Div tag and the jquery sentence had to be div > a loosing sense"
html document addLoadScript:(
html jQuery page onShow:(
   	html jQuery couch db:'albums';view:'albums/albums';
					onSuccess:(( html jQuery:#listContent) 
							mustache: (html jQuery:#al) html
							data:((JSStream on:'attachmentsToArray') apply: (Array with:( html jQuery event)))
							command:'html'),
							((html jQuery:'li > a') onClick:(
										((html jQuery:#dataStorage) 
											dataAt:#currentDoc 
											put:	(html jQuery this attributeAt: 'id')),
										((html jQuery:#dataStorage) 
											dataAt:#currentRev 
											put:	(html jQuery this attributeAt: 'title')))),
							((html jQuery:#listContent) jqmListView refresh);
					onError:((html jQuery:#alist) html:'Error in connection')
		 
		)
)	! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:22'!
renderContentOn:html

	self renderAlbumListHeaderOn:html.
	self renderAlbumListContentOn:html.
	self renderAlbumListFooterOn:html.
	self renderAlbumListLoadScriptOn:html.
	
	! !

WAComponent subclass: #JQAlbumsLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile'!

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/12/2013 02:26'!
initialize
super initialize.

! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 18:22'!
json
	^ JSJson new
! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 21:32'!
renderContentOn:html
	self renderLoginHeaderOn:html.
 	self renderLoginContentOn:html.
   	self renderLoginFooterOn:html! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 11:03'!
renderFormElementOn: html element: elementBlock
	html div
		jqmFieldContainer;
		with: [
			elementBlock value ]! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 19:05'!
renderLoginContentOn:html
  html div
      jqmContent;
      with: [
	html form: [
  
		self renderFormElementOn:html element: [
			html label
				for: #uName;
				with: 'UserName:'.
			html textInput
				id: #uName.
		].
	
		self renderFormElementOn:html element: [
     			 html label
         			for: #passw;
         			with: 'Password:'.
      		html passwordInput
         			id: #passw.
		].
	].	
].
 ! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 19:20'!
renderLoginFooterOn:html
html div
      jqmFooter;
	jqmFixedPosition;	
      with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor
								onClick:((JSStream on:'history') call:'back');
								with: 'Cancel' ].
						html listItem: [
							html anchor jqmTransitionSlide	
							onClick: (html jQuery ajax script:[:s | s<<(self renderLoginScriptOn:s)]);
							with: 'Submit' 
							] ] ].

] ! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 11:21'!
renderLoginHeaderOn:html
html div
      jqmHeader;
      with: [
         html heading
            level1;
            with:       [	html span:'CouchDB Status:'.
		html code id:#logger; with:'waiting for connection']].
   ! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:27'!
renderLoginScriptOn:js
"password is sended in plain text, don't do that in a real app otherwise use https or cipher the password"
^(js jQuery couch login:((js jQuery:'#uName') value) password:((js jQuery:'#passw') value) ;
				onSuccess:(( js jQuery:#logger) html: 'Logged-in at ', DateAndTime now asString),
							(js jQuery ajax callback:[:v|
								self session sessionData:(JSJsonParser parse: v)
								]
								value:(self json stringify:js jQuery event)),
								((JSStream on:'history') call:'back');
				onError:((js jQuery:#logger) html: 'Error in connection at  ', DateAndTime now asString)) 
! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:27'!
updateRoot:anHtmlRoot
"always as a dialog box"
anHtmlRoot pageDivAttributes at: 'data-role' put: 'dialog'! !

WAComponent subclass: #JQSCouchDBTest
	instanceVariableNames: 'textInput aCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional'!

!JQSCouchDBTest class methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/11/2012 18:12'!
canBeRoot
^true! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/1/2013 13:11'!
json
	^ JSJson new! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 20:23'!
renderContentOn:html
"self requestContext response headers at:'Access-Control-Allow-Origin' put:'"
html heading:'Demo CouchDB'.
self renderCouchInitOn:html.
self renderDocOn:html.
self renderTemplateOn:html! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:23'!
renderCouchInitOn:html
	html div with:[
		html span:'Status:'.
		html code id:#logger; with:'waiting for connection'.
		].
	html script:(
		html jQuery ready:(
			"don't do that in a real app"
			html jQuery couch login:'admin' password:'admin' ;
				onSuccess:( 
					html jQuery ajax script:[:s|s << (s jQuery:#logger) html: 'Logged-in at ', DateAndTime now asString]);
				onError:( 
					html jQuery ajax script:[:s|s << (s jQuery:#logger) html: 'Error in connection at  ', DateAndTime now asString]))
		)! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 11:00'!
renderCouchLoadViewOn:js 
"Server side style"
	^ js jQuery couch db:'test';allDocs;
		onSuccess: 
					((js jQuery:#serverSide) load 
							html:[:html|
								html paragraph:( aCollection at:'total_rows').
								aCollection
								ifNil:[html paragraph]
								 ifNotNil:[
									(aCollection at:'rows' ) do:[:i|
										 html paragraph:(i at:#id). 
									].
								]
							];
					callback:[:data|
						aCollection:= JSJsonParser parse: data.
						]	 
					value: (self json stringify: js jQuery event))! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 13:56'!
renderCouchLoadViewOnNew:js 
"client side style- using a mustache template rendered on client side"
	^ js jQuery couch db:'test';allDocs;
		onSuccess: 
					((js jQuery:#clientSide)  
							mustache: (js jQuery:#test1) html
							data:(js jQuery event)
							partials: 
							(GRSmallDictionary new
								at: 'part1'
								put: (js jQuery:#part1) html;
								yourself)
							command:'html'
					)! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 10:54'!
renderCouchSaveDocOn:js content:aWord

	js << js jQuery couch db:'test';saveDoc: (JSStream on:'{"word":"', aWord,'"}');
				onSuccess: (
							(self renderCouchLoadViewOnNew: js),
							(self renderCouchLoadViewOn: js)
						).
	
	
		! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 10:57'!
renderDocOn:html
 self
      renderLabel: 'Text-Input'
      control: [ :id :script |
         html textInput
            id: id;
            value: textInput;
            callback: [ :value | textInput := value ];
            onChange: (script html: [ :h | h render: textInput ]).
         "the following code checks if a manual submit does a correct encoding:"
         html submitButton
            onClick: (html jQuery ajax
               callback: [ :value | textInput := value ] 
		   value: (html jQuery id: id) value;
               script: [ :s | 
				self renderCouchSaveDocOn: s content: textInput.
				]);
            with: 'Manual Submit'.
  	 ]
      model: textInput
      on: html.

	html table id:#dataList; with:[
		html tableData with:[
			html paragraph id:#clientSide
			].
		html tableData with:[
			html paragraph id:#serverSide 
	] 
].

! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/11/2012 18:06'!
renderLabel: aString control: aBlock model: anObject on: html
   | id |
   html fieldSet: [
      html label
         for: (id := html nextId);
         with: aString.
      html span: [
         aBlock
            value: id
            " update the paragraph "
            value: ((html jQuery this	
               parents: 'fieldset';
               find: 'p') load
                  " serialize all nearby form elements "
                  serialize: (html jQuery this		
                     parents: 'span';
                     find: ':input')) ].
      html paragraph: anObject ]
! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 14:10'!
renderTemplateOn:html
html mustache
		template:'test1';
		with:[
			html paragraph:( html mustache variable:'total_rows').
			
				html mustache section 
						name:'rows';
						with: [(html mustache includePartial: 'part1')]
			].
html mustache
		template:'part1';
		with:[
		 html paragraph:(html mustache variable:'id')
		]! !

WASession subclass: #JQAlbumsSession
	instanceVariableNames: 'sessionData currentDoc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile'!

!JQAlbumsSession methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 16:21'!
currentDoc
^ currentDoc
! !

!JQAlbumsSession methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 15:50'!
currentDoc: docId
currentDoc:=docId
! !

!JQAlbumsSession methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 18:32'!
initialize
super initialize.
sessionData:=nil! !

!JQAlbumsSession methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 18:37'!
loggedIn
^self  sessionData notNil.! !

!JQAlbumsSession methodsFor: 'accessing' stamp: 'JesusMari 2/8/2013 18:28'!
sessionData
	^ sessionData! !

!JQAlbumsSession methodsFor: 'accessing' stamp: 'JesusMari 2/8/2013 18:28'!
sessionData: anObject
	sessionData := anObject! !

JSObjectTest subclass: #JQueryCouchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests'!

JQueryCouchTest subclass: #JQueryCouchDbTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests'!

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/30/2012 23:16'!
couch
	^ self jQuery couch! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 00:13'!
couchDb
	^ self jQuery couchDb! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/13/2013 00:30'!
test0Couch
	self
		assert: (self jQuery couch)
		equals: self function , '.couch'.
self
		assert: (self jQuery couch urlPrefix:'http://localhost:5984')
		equals: self function , '.couch.urlPrefix="http://localhost:5984"'.
		
	self
		assert: (self jQuery couch urlPrefix)
		equals: self function , '.couch.urlPrefix'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:58'!
test0Database

	self
		assert: (self jQuery couch db:'test';create)
		equals: self function , '.couch.db("test").create'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/13/2013 00:45'!
test0EncodeDocId

	self
		assert: (self jQuery couch encodeDocId:'test')
		equals: self function , '.couch.encodeDocId("test")'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:58'!
test1Info

	self
		assert: (self jQuery couch info;onSuccess:'alert(data);')
		equals: self function , '.couch.info({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:04'!
test2allDbs

	self
		assert: (self jQuery couch allDbs)
		equals: self function , '.couch.allDbs'.
	self
		assert: (self jQuery couch allDbs;onSuccess:'alert(data);')
		equals: self function , '.couch.allDbs({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test3SignUp
|user|

	
	self
		assert: (self jQuery couch signUp:'bob' password:'superpassword')
		equals: self function , '.couch.signup({"_id":"org.couchdb.user:bob","name":"bob"},"superpassword")'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test4Login


	
	self
		assert: (self jQuery couch login:'bob' password:'superpassword';onSuccess:'done')
		equals: self function , '.couch.login({"success":function(data){done},"password":"superpassword","name":"bob"})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test5session

	self
		assert: (self jQuery couch session;onSuccess:'alert(data);')
		equals: self function , '.couch.session({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test6logout

	self
		assert: (self jQuery couch logout;onSuccess:'alert(data);')
		equals: self function , '.couch.logout({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test7activeTasks

	self
		assert: (self jQuery couch activeTasks;onSuccess:'alert(data);')
		equals: self function , '.couch.activeTasks({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test8config

	self
		assert: (self jQuery couch config:'uuids'option:'algorithm';onSuccess:'alert(data);')
		equals: self function , '.couch.config({"success":function(data){alert(data);}},"uuids","algorithm")'.
	self
		assert: (self jQuery couch config:'uuids'option:'algorithm'value:'sequential';onSuccess:'alert(data);')
		equals: self function , '.couch.config({"success":function(data){alert(data);}},"uuids","algorithm","sequential")'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test9userDb

	self
		assert: (self jQuery couch userDb:'alert(data);')
		equals: self function , '.couch.userDb(function(data){alert(data);})'.
! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
testAnewUUID

	self
		assert: (self jQuery couch newUUID)
		equals: self function , '.couch.newUUID()'.
! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
testBReplicateDatabase

	self
		assert: (self jQuery couch replicate:'DB' to:'NEWDB' createTarget:true;onSuccess:'done';onError:'error')
		equals: self function , '.couch.replicate("DB","NEWDB",{"success":function(data){done},"error":function(status){error}},{"create_target":true})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testCDatabaseCreate

	self
		assert: (self jQuery couch db:'test';create;onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").create({"success":function(data){done},"error":function(status){error}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testDDatabaseInfo

	self
		assert: (self jQuery couch db:'test';info;onSuccess:'done')
		equals: self function , '.couch.db("test").info({"success":function(data){done}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/10/2013 21:52'!
testEsaveDoc

	self
		assert: (self jQuery couch db:'test';saveDoc:'aDoc';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").saveDoc("aDoc",{"success":function(data){done},"error":function(status){error}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testFopenDoc

	self
		assert: (self jQuery couch db:'test';openDoc:'d12ee5ea1df6baa2b06451f44a019ab9';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").openDoc("d12ee5ea1df6baa2b06451f44a019ab9",{"success":function(data){done},"error":function(status){error}})'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testGremoveDoc

	self
		assert: (self jQuery couch db:'test';removeDoc:'aDoc';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").removeDoc("aDoc",{"success":function(data){done},"error":function(status){error}})'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/17/2013 08:49'!
testHbulkSave

|aDoc|
	aDoc:=GRSmallDictionary new.
	aDoc at:'docs' put: 'aDocument'.
	
	self
		assert: (self jQuery couch db:'test';bulkSave:(aDoc);onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").bulkSave({"docs":"aDocument"},{"success":function(data){done},"error":function(status){error}})'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/17/2013 08:51'!
testIbulkRemove

|aDoc|
	aDoc:=GRSmallDictionary new.
	aDoc at:'docs' put: 'aDocument'.
	self
		assert: (self jQuery couch db:'test';bulkRemove:aDoc;onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").bulkRemove({"docs":"aDocument"},{"success":function(data){done},"error":function(status){error}})'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testJallDocs

	self
		assert: (self jQuery couch db:'test';allDocs;onSuccess:'done')
		equals: self function , '.couch.db("test").allDocs({"success":function(data){done}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testKallDesignDocs

	self
		assert: (self jQuery couch db:'test';allDesignDocs;onSuccess:'done')
		equals: self function , '.couch.db("test").allDesignDocs({"success":function(data){done}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testKquery

	self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},"_count","javascript",{"reduce":false,"success":function(data){done}})'.
		
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"javascript",{"reduce":false,"success":function(data){done}})'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk';onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":false,"success":function(data){done}})'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk' reduce:true;onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":true,"success":function(data){done}})'		! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testLallApps

	self
		assert: (self jQuery couch db:'test';allApps;forEachApp:('console.log(appName+" "+appPath+" "+ddoc');onSuccess:'done')
		equals: self function , '.couch.db("test").allApps({"success":function(data){done},"eachApp":function(appName,appPath,ddoc){console.log(appName+" "+appPath+" "+ddoc}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testMquery

self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},"_count","javascript",{"reduce":false,"success":function(data){done}})'.
		
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"javascript",{"reduce":false,"success":function(data){done}})'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk';onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":false,"success":function(data){done}})'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk' reduce:true;onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":true,"success":function(data){done}})'		! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testOview

	self
		assert: (self jQuery couch db:'test';view:('default/all');onSuccess:'done';onError:'err';reduce:false)
		equals: self function , '.couch.db("test").view("default/all",{"reduce":false,"success":function(data){done},"error":function(status){err}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testPlist

	self
		assert: (self jQuery couch db:'test';list:('default/all') with:'all';onSuccess:'done';onError:'err';reduce:false)
		equals: self function , '.couch.db("test").list("default/all","all",{"reduce":false,"success":function(data){done},"error":function(status){err}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testQcompact

	self
		assert: (self jQuery couch db:'test';compact;onSuccess:'done')
		equals: self function , '.couch.db("test").compact({"success":function(data){done}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testRviewCleanup

	self
		assert: (self jQuery couch db:'test';viewCleanup;onSuccess:'done')
		equals: self function , '.couch.db("test").viewCleanup({"success":function(data){done}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:02'!
testScompactView

	self
		assert: (self jQuery couch db:'test';compactView:'default';onSuccess:'done')
		equals: self function , '.couch.db("test").compactView("default",{"success":function(data){done}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:02'!
testTchange

	self
		assert: (self jQuery couch db:'test';onChange:'done')
		equals: self function , '.couch.db("test").changes().onChange(function(data){done})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:02'!
testUdrop

	self
		assert: (self jQuery couch db:'test';drop;onSuccess:'done')
		equals: self function , '.couch.db("test").drop({"success":function(data){done}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:02'!
testVcopyDoc

	self
		assert: (self jQuery couch db:'test';copyDoc:'11111';onSuccess:'done';onError:'err';beforeSend:'send')
		equals: self function , '.couch.db("test").copyDoc("11111",{"success":function(data){done},"error":function(status){err}},{"beforeSend":function(xhr){send}})'.
		
	! !

!JQueryCouchTest class methodsFor: 'testing' stamp: 'JesusMari 3/30/2012 23:13'!
isAbstract
	^ self name = #JQueryTest! !

!JQueryCouchTest class methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
packageNamesUnderTest
	^ #('JQuery-Core')! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
function
	"Answers the name of the jQuery function. This can be either '$' or 'jQuery' or any other user chosen name. This makes sure the tests run in any case."

	^ JQuery functionName! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
jQuery
	^ JQueryClass context: self renderContext! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
jQuery: anObject
	^ self jQuery with: anObject! !
